<?php
/**
* MyPhotoCoursePlugin.class.php
* 
* Plugin zum Verwalten von Photoalben in Veranstaltungen
* 
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*
* DEDICATION
*
* This plugin is dedicated to my one and only very best girl friend Nadine.
*
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2007 Jan Kulmann <jankul@zmml.uni-bremen.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+

require_once("classes/myphoto/MyPhoto.class.php");
require_once("classes/myphoto/Photo.class.php");
require_once("classes/myphoto/Album.class.php");
require_once("classes/myphoto/Comment.class.php");
require_once("classes/myphoto/Controller.class.php");
require_once("classes/scorm/ScormExport.class.php");
require_once ($GLOBALS['ABSOLUTE_PATH_STUDIP']."functions.php");
require_once ($GLOBALS['ABSOLUTE_PATH_STUDIP']."messaging.inc.php");

class MyPhotoCoursePlugin extends AbstractStudIPStandardPlugin {

	var $view;
	var $items_per_page = 16;
	var $mp;

	function MyPhotoCoursePlugin(){
		parent::AbstractStudIPStandardPlugin();
		bindtextdomain('mp',dirname(__FILE__).'/locale');
		$this->setPluginIconName('images/myphoto_icon.jpg');
		$this->mp = new MyPhoto();
	}
	
	function setPluginpath($newpath){
		parent::setPluginpath($newpath);
		$this->buildMenu();
	}

	function buildMenu(){
		global $SessSemName, $perm;
		$tab = new PluginNavigation();
		$tab->setDisplayname(_("MyPhotos"));
		$tab->setActive();

		if ($perm->have_studip_perm("tutor",$SessSemName[1])) {
			$subnav = new PluginNavigation();
			$subnav->setDisplayname(_("Neues Album"));
			$subnav->setActive();
			$subnav->setLinkParam("new_album");
			$tab->addSubmenu($subnav);
		}
		$subnav2 = new PluginNavigation();
		$subnav2->setDisplayname(_("Alben bearbeiten"));
		$subnav2->setActive();
		$subnav2->setLinkParam("admin_mode");
		$tab->addSubmenu($subnav2);

		$this->setNavigation($tab); 
		$this->mp->set_homepage_view(FALSE);
		$this->mp->set_range_id($SessSemName[1]);
	}

	function getNavigation() {
		$this->mp->setPluginobject($this);
		return $this->navigation;
	}

	function getPluginName() {
		return "MyPhotos";
	}

	function show() {
		global $SessSemName, $perm;
		
		$this->mp->get_stylesheets();

		$this->view = "show";
		$modus = $_REQUEST['modus'];
		$c = new Controller();
		// Sind wir berechtigt?
		if ($perm->have_studip_perm("tutor",$SessSemName[1]) && $_REQUEST['plugin_subnavi_params'] == "new_album") {
			$this->mp->new_album();
		} else if ($perm->have_studip_perm("autor",$SessSemName[1]) && $_REQUEST['plugin_subnavi_params'] == "admin_mode") {
		//if ($perm->have_studip_perm("dozent",$SessSemName[1])) {
			//$this->view = "show";
			/*if ($_REQUEST['plugin_subnavi_params'] == "new_album") {
				$this->mp->new_album();
			}*/
			$messaging=new messaging;
			
			// modus....
			if ($modus == "scorm_export") {
                                $a = new Album();
                                $a->load($_REQUEST['album_id']);
                                $scorm = new ScormExport($a, $this->getPluginpath(), $this->mp->get_range_id());
                                $scorm->initialize();
                                if ($scorm->error) {
					echo $scorm->error;
					unset($modus);
                                } else {
                                        $modus = "view_album";
                                        //echo "<IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/gruen.gif\">&nbsp;".sprintf("Sie k&ouml;nnen die Datei %s<B>hier</B>%s herunterladen.","<A HREF=\"".GetDownloadLink($scorm->getExportFilename(),"scormexport.zip",2)."\">","</A>");
					$m = sprintf(_("Sie k&ouml;nnen die Datei %s<B>hier</B>%s herunterladen."),"<A HREF=\"".GetDownloadLink($scorm->getExportFilename(),"scormexport.zip",2)."\">","</A>");
					parse_msg("msg".$m);
                                }
                        }
			if ($modus == "del_photo") {
				$p = new Photo();
				$p->load($_REQUEST['photo_id']);
				$p_user_id = $p->get_user_id();
				$a = new Album();
				$a->load($p->get_album_id());
				//if ($p->get_user_id() == $GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm("root")) {
				if ($a->is_in_range($SessSemName[1]) && Controller::haveEditPerms($a,$this->mp->get_range_id())) {
					$p->delete();
					if ($_REQUEST['photo_id'] == $a->get_start_photo_id()) {
						$a->set_start_photo_id("");
						$a->save();
					}
					if ($p_user_id != $GLOBALS['auth']->auth['uid']) {
						$msg = sprintf(_("Ein Foto im Album \"%s\" wurde von einer/einem DozentIn der Veranstaltung **%s** oder der Administration gelscht."),$a->get_titel(),$SessSemName[0]);
						$messaging->insert_message(mysql_escape_string($msg), get_username($p_user_id), "____%system%____", FALSE, FALSE, 1, FALSE, _("Foto gelscht"));
					}
					parse_msg("msg"._("Das Foto wurde gel&ouml;scht."));
				}
				$modus = "view_album";
			}
			if ($modus == "del_album") {
				$a = new Album();
				$a->load($_REQUEST['album_id']);
				$a_user_id = $a->get_user_id();
				$titel = $a->get_titel();
				//if ($a->get_user_id() == $GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm("root")) {
				if ($a->is_in_range($SessSemName[1]) && Controller::haveEditPerms($a,$this->mp->get_range_id())) {
					$a->delete();
					if ($a_user_id != $GLOBALS['auth']->auth['uid']) {
						$msg = sprintf(_("Das Album \"%s\" wurde von einer/einem DozentIn der Veranstaltung **%s** oder der Administration gelscht."),$titel,$SessSemName[0]);
						$messaging->insert_message(mysql_escape_string($msg), get_username($a_user_id), "____%system%____", FALSE, FALSE, 1, FALSE, _("Album gelscht"));
					}
					parse_msg("msg"._("Das Album wurde gel&ouml;scht."));
				}
				$modus = FALSE;
			}
			if ($modus == "del_comment") {
				$comment = new Comment();
				$comment->load($_REQUEST['comment_id']);
				$p = new Photo();
				$p->load($_REQUEST['photo_id']);
				$a = new Album();
				$a->load($p->get_album_id());
				//if ($p->get_user_id() == $GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm("root")) {
				if ($a->is_in_range($SessSemName[1]) && Controller::haveEditPerms($a,$this->mp->get_range_id())) {
					$comment->delete();
					if ($p->get_user_id() != $GLOBALS['auth']->auth['uid']) {
						$a = new Album();
						$a->load($p->get_album_id());
						$msg = sprintf(_("Ein Kommentar im Album \"%s\" wurde von einer/einem DozentIn der Veranstaltung **%s** oder der Administration gelscht."),$a->get_titel(),$SessSemName[0]);
						$messaging->insert_message(mysql_escape_string($msg), get_username($p->get_user_id()), "____%system%____", FALSE, FALSE, 1, FALSE, _("Kommentar gelscht"));
					}
					parse_msg("msg"._("Der Kommentar wurde gel&ouml;scht."));
				}
				$modus = "show_photo_maxsize";
			}
			if ($modus == "add_album") {
				if (strlen(trim($_REQUEST['titel'])) > 0) {
					$a = new Album();
					$a->set_titel(trim($_REQUEST['titel']));
					$a->set_untertitel(trim($_REQUEST['untertitel']));
					$a->set_beschreibung(trim($_REQUEST['beschreibung']));
					$a->set_user_id($GLOBALS['auth']->auth['uid']);
					$a->set_mkdate(time());
					//$a->set_range_id($SessSemName[1]);
					$a->save();
					$a->add_range($SessSemName[1], $GLOBALS['auth']->auth['perm']);
					parse_msg("msg"._("Das Album wurde erstellt."));
					$modus = "view_album";
					$_REQUEST['album_id'] = $a->get_album_id();
				} else $modus = FALSE;
			}
			if ($modus == "save_album") {
				if (strlen(trim($_REQUEST['titel'])) > 0) {
					$sortierung = explode("photos[]=", preg_replace(array("/\&/"),array(""),$_REQUEST['sortierung']));
					$a = new Album();
					$a->load($_REQUEST['album_id']);
					if (Controller::haveEditPerms($a,$this->mp->get_range_id())) {
						$a->set_titel(trim($_REQUEST['titel']));
						$a->set_untertitel(trim($_REQUEST['untertitel']));
						$a->set_beschreibung(trim($_REQUEST['beschreibung']));
						$a->set_public($_REQUEST['public']);
						$a->set_allow_comments($_REQUEST['allow_comments']);
						$a->set_start_photo_id($_REQUEST['photo_id']);
						$a->set_edit_mode($SessSemName[1],$_REQUEST['edit_mode']);
						$a->save();
						$count = 0;
						foreach ($sortierung as $sort) {
							if (trim($sort) != "") {
								Photo::update_sort($sort, $count, $SessSemName[1]);
								$count++;
							}
						}
						parse_msg("msg"._("Die Einstellungen wurden gespeichert."));
					}
				}
				$modus = "view_album";
			}
			if ($modus == "save_photo") {
				$p = new Photo();
                                $p->load($_REQUEST['photo_id']);
				$a = new Album();
				$a->load($p->get_album_id());
				if (Controller::haveEditPerms($a,$this->mp->get_range_id())) {
	                                $old_album_id = $p->get_album_id();
        	                        $p->set_titel($_REQUEST['titel']);
                	                $p->set_beschreibung($_REQUEST['beschreibung']);
                        	        if ($_REQUEST['photo2album_move_id'] != "") {
                                	        $p->set_album_id($_REQUEST['photo2album_move_id']);
                                        	$p->save();
	                                        parse_msg("msg"._("Das Foto wurde verschoben."));
        	                                $modus = "view_album";
                	                        $_REQUEST['album_id'] = $old_album_id;
                        	        } else {
                                	        $p->save();
                                        	parse_msg("msg"._("Das Foto wurde gepeichert."));
	                                        $modus = "show_photo_maxsize";
					}
                                }
			}
			if ($modus == "make_comment") {
				$co = new Comment();
				$co->set_photo_id($_REQUEST['photo_id']);
				$co->set_user_id($GLOBALS['auth']->auth['uid']);
				$co->set_mkdate(time());
				$co->set_comment($_REQUEST['comment']);
				$co->save();
				$modus = "show_photo_maxsize";
			}
			if ($modus == "show_photo_maxsize") {
                                $p = new Photo();
                                $p->load($_REQUEST['photo_id']);
				$a = new Album();
				$a->load($p->get_album_id());
				if (Controller::haveEditPerms($a,$this->mp->get_range_id()) && $_REQUEST['rotate'] && ($_REQUEST['rotate'] == 'left' || $_REQUEST['rotate'] == 'right')) {
                                        $img = imagecreatefromstring(base64_decode($p->get_file_content()));
                                        $img_thumb = imagecreatefromstring(base64_decode($p->get_file_content_thumb()));
                                        if ($_REQUEST['rotate'] == "left")
                                                $degree = 90;
                                        else
                                                $degree = 270;

                                        $img2 = $c->rotate($img, $degree);
                                        $img2_thumb = $c->rotate($img_thumb, $degree);

                                        $c_file = $GLOBALS['TMP_PATH']."/".md5(uniqid(time()));
                                        $t_file = $GLOBALS['TMP_PATH']."/".md5(uniqid(time()));
                                        if ($p->get_ext() == "gif") {
                                                $f = imagegif($img2, $c_file);
                                                $f_thumb = imagegif($img2_thumb, $t_file);
                                        } else {
                                                $f = imagejpeg($img2, $c_file);
                                                $f_thumb = imagejpeg($img2_thumb, $t_file);
                                        }
                                        $p->set_file_content(base64_encode(file_get_contents($c_file)), base64_encode(file_get_contents($t_file)), TRUE);
                                        unlink($c_file);
                                        unlink($t_file);
                                }
				$this->mp->admin_show_foto_maxsize($_REQUEST['photo_id']);
			}
			if ($modus == "add_photos") {
				$this->mp->new_file_upload(PluginEngine::getLink($this,array()), $_REQUEST['album_id']);
			}
			if ($modus == "foto_upload") {
				$a = new Album();
				$a->load($_REQUEST['album_id']);
				if (Controller::haveEditPerms($a,$this->mp->get_range_id())) {
					global $imgfile, $imgfile_name, $imgfile_size;
					if ($imgfile && $_REQUEST['album_id']) {
						$msg = $c->add_new_foto($imgfile, $imgfile_size, $imgfile_name, $_REQUEST['album_id'], $_REQUEST['titel'], $_REQUEST['beschreibung']);
						if ($msg)
							parse_msg($msg);
					}
					$modus = "view_album";
				} else $modus = FALSE;
			}
			// ZIP-Upload
			if ($modus == "zip_upload") {
				$a = new Album();
				$a->load($_REQUEST['album_id']);
				if (Controller::haveEditPerms($a,$this->mp->get_range_id())) {
					global $zipfile, $zipfile_name, $zipfile_size;
					if ($zipfile && $_REQUEST['album_id']) {
						$msg = $c->add_new_zip($zipfile, $zipfile_size, $zipfile_name, $_REQUEST['album_id']);
						if ($msg)
							parse_msg($msg);
					}
					$modus = "view_album";
				} else $modus = FALSE;
			}
			if ($modus == "view_album") {
				$this->mp->admin_view_album($_REQUEST['album_id']);
			}
			
			//if (!$_REQUEST['plugin_subnavi_params'] && !$modus)
			if (!$modus)
				$this->mp->admin_show_albums();
		} else { // normaler Teilnehmer oder Tutor
			if (($album_id = $this->mp->the_one_and_only_album()) && !$modus) {
				$modus = "view_album";
				$_REQUEST['album_id'] = $album_id;
			}
			if ($modus != "") {
				if ($modus == "view_album") {
		        	        $this->mp->public_view_album($_REQUEST['album_id']);
                		}
				if ($modus == "make_comment") {
        	                        $co = new Comment();
                	                $co->set_photo_id($_REQUEST['photo_id']);
                        	        $co->set_user_id($GLOBALS['auth']->auth['uid']);
                                	$co->set_mkdate(time());
	                                $co->set_comment($_REQUEST['comment']);
        	                        $co->save();
					$p = new Photo();
					$p->load($_REQUEST['photo_id']);
					$a = new Album();
					$a->load($p->get_album_id());
					$messaging=new messaging;
					$msg = sprintf(_("%s hat ein Foto im Album \"%s\" kommentiert."),get_vorname($GLOBALS['auth']->auth["uid"]),$a->get_titel());
					$messaging->insert_message(mysql_escape_string($msg), get_username($p->get_user_id()), $GLOBALS['auth']->auth["uid"], FALSE, FALSE, 1, FALSE, _("Foto-Kommentar"));
	                                $modus = "show_photo_maxsize";
        	                }
				if ($modus == "show_photo_maxsize") {
					$this->mp->public_show_foto_maxsize($_REQUEST['photo_id']);
				}
			} else
				$this->mp->public_show_albums(TRUE); 
		} 
	}

}

?>
