<?php
/**
* Controller.class.php
*
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2007 Jan Kulmann <jankul@zmml.uni-bremen.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


require_once $GLOBALS['ABSOLUTE_PATH_STUDIP'].("functions.php");

require_once("Album.class.php");
require_once("Photo.class.php");
require_once("Comment.class.php");

class Controller {

	var $max_quota_size;

	function Controller() {
		$this->max_quota_size = get_config('PHOTO_UPLOAD_QUOTA');
	}

	function copy_album($album_id, $new_range_id) {
		if ($album_id != "" && $new_range_id != ""){
			$new_album = new Album();
			$new_album->load($album_id);
			$new_album->set_album_id("");
			$new_album->set_start_photo_id("");
			$new_album->save();
			$new_album->add_range($new_range_id,'dozent');
			foreach ($this->get_all_photos_in_album($album_id) as $p) {
				$content = $p->get_file_content();
				$thumb   = $p->get_file_content_thumb();
				$p->set_photo_id("");
				$p->set_album_id($new_album->get_album_id());
				$p->set_file_id(Photo::get_new_id());
				$p->save();
				$p->set_file_content($content, $thumb);
			}
		}
	}	

	function haveEditPerms($album, $range_id) {
                $edit_mode = $album->get_edit_mode($range_id);
                if ($GLOBALS['perm']->have_perm('root') ||
                        $album->get_user_id() == $GLOBALS['auth']->auth['uid'] ||
                        $GLOBALS['perm']->have_studip_perm(($edit_mode?$edit_mode:'dozent'),$range_id)
                    )
                        return TRUE;
                else
                        return FALSE;
        }

	function get_alternative_ranges($photo_id) {
		$ret = array();
		$p = new Photo();
		$p->load($photo_id);
                $db = new DB_Seminar();
		$db->queryf("SELECT r.range_id, r.album_id, a.titel FROM mp_range r, mp_album a WHERE a.user_id='%s' AND r.album_id=a.album_id AND a.album_id!='%s'",$p->get_user_id(), $p->get_album_id());
		while ($db->next_record()) {
			array_push($ret, array("range_id"=>$db->f("range_id"), "album_id"=>$db->f("album_id"), "titel"=>$db->f("titel")));
		}
		return $ret;
	}

	function get_all_albums($range_id) {
		$ret = array();
		$db = new DB_Seminar();
		//$db->queryf("SELECT r.album_id, a.sort, a.mkdate FROM mp_range r, mp_album a WHERE r.range_id='%s' AND a.album_id=r.album_id ORDER BY a.sort, a.mkdate",$range_id);
		$db->queryf("SELECT r.album_id, r.sort, a.mkdate FROM mp_range r, mp_album a WHERE r.range_id='%s' AND a.album_id=r.album_id ORDER BY r.sort, a.mkdate",$range_id);
		while ($db->next_record()) {
			$a = new Album();
			$a->load($db->f("album_id"));
			array_push($ret, $a);
		}
		return $ret;
	}

	function get_all_public_albums($range_id) {
		$ret = array();
		$db = new DB_Seminar();
		//$db->queryf("SELECT r.album_id, a.sort, a.mkdate FROM mp_range r, mp_album a WHERE r.range_id='%s' AND a.album_id=r.album_id AND a.public=1 ORDER BY a.sort, a.mkdate",$range_id);
		$db->queryf("SELECT r.album_id, r.sort, a.mkdate FROM mp_range r, mp_album a WHERE r.range_id='%s' AND a.album_id=r.album_id AND a.public=1 ORDER BY r.sort, a.mkdate",$range_id);
		while ($db->next_record()) {
			$a = new Album();
			$a->load($db->f("album_id"));
			array_push($ret, $a);
		}
		return $ret;
	}

	function get_seminare($album_id, $range_id) {
		$ret = array();
		$db = new DB_Seminar();
		$db->queryf("SELECT s.Seminar_id, s.VeranstaltungsNummer, s.Name, 0 verbunden, s.start_time FROM seminare s, seminar_user su WHERE su.user_id='%s' AND su.status='dozent' AND s.Seminar_id=su.Seminar_id AND NOT EXISTS (SELECT * FROM mp_range WHERE range_id=s.Seminar_id AND album_id='%s') UNION SELECT s.Seminar_id, s.VeranstaltungsNummer, s.Name, 1 verbunden, s.start_time FROM seminare s, seminar_user su WHERE su.user_id='%s' AND su.status='dozent' AND s.Seminar_id=su.Seminar_id AND EXISTS (SELECT * FROM mp_range WHERE range_id=s.Seminar_id AND album_id='%s') ORDER BY start_time DESC",$range_id,$album_id, $range_id, $album_id);
		while ($db->next_record()) {
			array_push($ret,array("seminar_id"=>$db->f("Seminar_id"), "vak"=>$db->f("VeranstaltungsNummer"), "name"=>$db->f("Name"), "verbunden"=>$db->f("verbunden")));
		}
		return $ret;
	}

	function get_public_viewable_album_count($range_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT a.album_id FROM mp_album a, mp_range r WHERE a.album_id=r.album_id AND r.range_id='%s' AND a.public=1",$range_id);
		return $db->num_rows();
	}

	function get_all_photos_in_album($album_id) {
		$ret = array();
		$db = new DB_Seminar();
		$db->queryf("SELECT photo_id FROM mp_photo WHERE album_id='%s' ORDER BY sort, mkdate",$album_id);
		while ($db->next_record()) {
			$p = new Photo();
			$p->load($db->f("photo_id"));
			array_push($ret, $p);
		}
		return $ret;
	}

	function get_first_photo_id($album_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT photo_id FROM mp_photo WHERE album_id='%s' ORDER BY sort, mkdate",$album_id);
		if ($db->next_record())
			return $db->f("photo_id");
		return "";
	}

	function get_number_of_all_photo_comments($photo_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT comment_id FROM mp_photo_comment WHERE photo_id='%s' ORDER BY mkdate DESC",$photo_id);
		return $db->num_rows();
	}

	function get_all_photo_comments($photo_id) {
		$ret = array();
		$db = new DB_Seminar();
		$db->queryf("SELECT comment_id FROM mp_photo_comment WHERE photo_id='%s' ORDER BY mkdate DESC",$photo_id);
		while ($db->next_record()) {
			$c = new Comment();
			$c->load($db->f("comment_id"));
			array_push($ret, $c);
		}
		return $ret;
	}

		// Wandelt Diskgroessen in lesbarere Schreibweisen um
	function translate_disksize($size) {
	        if ($size) {
	                $ret = "0 KB";
	                if ($size < 1024000) $ret = (round(($size / 1000),3)) . " KB"; // KB
	                if ($size > 1024000) $ret = (round(($size / 1000 / 1000),3)) . " MB"; // MB
	                if ($size > 1024000000) $ret = (round(($size / 1000 / 1000 / 1000),3)) . " GB"; // GB
	                return $ret;
	        }
	        return "0 KB";
	}
	
	function get_absolut_content_size_in_db($user_id) {
		if ($user_id != "") {
			$db = new DB_Seminar();
			$db->queryf("SELECT SUM(LENGTH(c.file_content_thumb)+LENGTH(c.file_content)) quota FROM mp_file_content c, mp_photo p WHERE p.user_id='%s' AND c.file_id=p.file_id",$user_id);
			if ($db->next_record())
				return $db->f("quota");
		}
		return 0;
	}

	function add_new_foto($imgfile, $imgfile_size, $imgfile_name, $album_id, $titel, $beschreibung) {
		if ($imgfile_size==0) return "error".dgettext('mp',"Fehler beim hochladen des Fotos! Dateigr&ouml;sse 0 Byte!")."";

		if ($this->get_absolut_content_size_in_db($GLOBALS['auth']->auth['uid']) > $this->max_quota_size)
			return "error".dgettext('mp',"Speicherplatz ersch&ouml;pft!");

		//Dateiendung bestimmen
	        $ext = NULL;
        	$dot = strrpos($imgfile_name,".");
	        if ($dot) {
        	        $l = strlen($imgfile_name) - $dot;
                	$ext = strtolower(substr($imgfile_name,$dot+1,$l));
	        }
		$db = new DB_Seminar();
		$db->queryf("SELECT MAX(sort) maxsort FROM mp_photo WHERE album_id='%s'",$album_id);
		$db->next_record();
		$max_sort = ($db->f("maxsort") ? $db->f("maxsort") : 1);
		$file_id = md5(uniqid(time()));
		$p = new Photo();
		$p->set_file_id($file_id);
		$msg = $this->imaging($p, $file_id, $imgfile, $imgfile_size, $imgfile_name);
                $pos = strpos($msg, "error");
		if ($pos===false) {
			$p->set_user_id($GLOBALS['auth']->auth['uid']);
			$p->set_album_id($album_id);
			$p->set_mkdate(time());
			$p->set_titel($titel);
			$p->set_beschreibung($beschreibung);
			$p->set_ext($ext);
			$p->set_sort($max_sort + 1);
			$p->save();
		} else
			$msg = "error".dgettext('mp',"Fehler beim hochladen des Fotos!")."";
		return $msg;
	}

	function imaging(&$photo_obj, $foto_id, $img, $img_size, $img_name) {
	        global $TMP_PATH, $CONVERT_PATH, $auth, $UPLOAD_PATH;
	
	        $max_file_size = 8000; //max Gre der Bilddatei in KB
	        $img_max_h_thumb = 160; // max picture height (thumbnail)
	        $img_max_h = 800; // max picture height
	        $img_max_w_thumb = 160; // max picture width (thumbnail)
	        $img_max_w = 800; // max picture width
	        //$uploaddir = $UPLOAD_PATH."/fotocontest"; //Uploadverzeichnis fr Bilder
	        $uploaddir = $TMP_PATH; //Uploadverzeichnis fr Bilder
	
	        $msg = "";
	        if ($img_size > ($max_file_size*1024)) { //Bilddatei ist zu gro
	                $msg = "errorError 1: " . sprintf(dgettext('mp',"Die hochgeladene Bilddatei ist %s KB gro&szlig;.<br>Die maximale Dateigr&ouml;&szlig;e betr&auuml;gt %s KB!"), round($img_size/1024), $max_file_size);
	                return $msg;
	        }
	
	        if (!$img_name) { //keine Datei ausgewhlt!
	                $msg = "errorError 2: " . dgettext('mp',"Sie haben keine Datei zum Hochladen ausgew&auml;hlt!");
	                return $msg;
	        }
	
	        //Dateiendung bestimmen
	        $dot = strrpos($img_name,".");
	        if ($dot) {
	                $l = strlen($img_name) - $dot;
	                $ext = strtolower(substr($img_name,$dot+1,$l));
	        }
	        //passende Endung ?
	        if ($ext != "jpg" && $ext != "gif" ) {
	                $msg = "error" . sprintf(dgettext('mp',"Der Dateityp der Bilddatei ist falsch (%s).<br>Es sind nur die Dateiendungen .gif und .jpg erlaubt!"), $ext);
	                return $msg;
	        }
	
	        //na dann kopieren wir mal...
	        $newfile = $uploaddir . "/foto_".$foto_id.".".$ext;
	        $newfile_thumb = $uploaddir . "/foto_thumb_".$foto_id.".".$ext;
	        if(!@copy($img,$newfile) || !@copy($img,$newfile_thumb)) {
	                @unlink($newfile);
	                @unlink($newfile_thumb);
	                $msg = "errorError 4: " . sprintf(dgettext('mp',"Es ist ein Fehler beim Kopieren der Datei %s aufgetreten. Das Bild wurde nicht hochgeladen!"),$img)."";
	                return $msg;
	        } else {
	                list($width, $height, $img_type, ) = @getimagesize($img);
	                // Check picture size
	                $hscale = $height / $img_max_h;
	                $wscale = $width / $img_max_w;
	                $hscale_thumb = $height / $img_max_h_thumb;
	                $wscale_thumb = $width / $img_max_w_thumb;
	                // Thumbnails
			if (($hscale_thumb > 1) || ($wscale_thumb > 1)) {
	                        $scale = ($hscale_thumb > $wscale_thumb)? $hscale_thumb : $wscale_thumb;
	                        $newwidth = floor($width / $scale);
	                        $newheight= floor($height / $scale);
	                        $ret_val = false;
	                        if (file_exists($CONVERT_PATH)){
	                                system($CONVERT_PATH . ' -resize ' . $newwidth . 'x' . $newheight . '! ' . $newfile_thumb .' ' . $newfile_thumb, $ret_val);
	                        } else if (extension_loaded('gd') && function_exists('imagecopyresampled')){
	                                // leeres Bild erzeugen
	                                $img_res = ImageCreateTrueColor($newwidth, $newheight);
	                                switch ($img_type) {  //original Bild einlesen
	                                case 1: //GIF
	                                        $img_org = ImageCreateFromGIF($img);
	                                        break;
	                                case 2: //JPG
	                                        $img_org = ImageCreateFromJPEG($img);
	                                        break;
	                                case 3: //PNG
	                                        $img_org = ImageCreateFromPNG($img);
	                                        break;
	                                default:
	                                        $img_org = FALSE;
	                                } // end switch
	                                if (!$img_org) {
	                                        $msg = "errorError 5: " . dgettext('mp',"Es ist ein Fehler beim Kopieren der Datei aufgetreten. Das Bild wurde nicht hochgeladen!");
	                                        @unlink($newfile);
	                                        @unlink($newfile_thumb);
	                                        return $msg;
	                                }
	                                // resampeln und als jpg speichern
	                                $ret_val = ImageCopyResampled ( $img_res, $img_org, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
	                                $ret_val = ImageJPEG ( $img_res, $newfile_thumb , 70);
	                                $ret_val = $ret_val ? false : true;
	                                ImageDestroy ( $img_res);
	                                ImageDestroy ( $img_org);
	                        } else {
	                                $ret_val = true; //Fehler!!!
	                        }
	                        if ($ret_val){
	                                @unlink($newfile);
	                                @unlink($newfile_thumb);
	                                $msg = "errorError 6:" . dgettext('mp',"Es ist ein Fehler beim Kopieren der Datei aufgetreten. Das Bild wurde nicht hochgeladen!");
	                                return $msg;
	                        }
	                }
	                // Big-Images
	                if (($hscale > 1) || ($wscale > 1)) {
	                        $scale = ($hscale > $wscale)? $hscale : $wscale;
	                        $newwidth = floor($width / $scale);
	                        $newheight= floor($height / $scale);
	                        $ret_val = false;
	                        if (file_exists($CONVERT_PATH)){
	                                system($CONVERT_PATH . ' -resize ' . $newwidth . 'x' . $newheight . '! ' . $newfile .' ' . $newfile, $ret_val);
	                        } else if (extension_loaded('gd') && function_exists('imagecopyresampled')){
	                                // leeres Bild erzeugen
	                                $img_res = ImageCreateTrueColor($newwidth, $newheight);
	                                switch ($img_type) {  //original Bild einlesen
	                                case 1: //GIF
						$img_org = ImageCreateFromGIF($img);
	                                        break;
	                                case 2: //JPG
	                                        $img_org = ImageCreateFromJPEG($img);
	                                        break;
	                                case 3: //PNG
	                                        $img_org = ImageCreateFromPNG($img);
	                                        break;
	                                default:
	                                        $img_org = FALSE;
	                                } // end switch
	                                if (!$img_org) {
	                                        $msg = "errorError 7: " . dgettext('mp',"Es ist ein Fehler beim Kopieren der Datei aufgetreten. Das Bild wurde nicht hochgeladen!");
	                                        @unlink($newfile);
	                                        @unlink($newfile_thumb);
	                                        return $msg;
	                                }
	                                // resampeln und als jpg speichern
	                                $ret_val = ImageCopyResampled ( $img_res, $img_org, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
	                                $ret_val = ImageJPEG ( $img_res, $newfile , 70);
	                                $ret_val = $ret_val ? false : true;
	                                ImageDestroy ( $img_res);
	                                ImageDestroy ( $img_org);
	                        } else {
	                                $ret_val = true; //Fehler!!!
	                        }
	                        if ($ret_val){
	                                @unlink($newfile);
	                                @unlink($newfile_thumb);
	                                $msg = "errorError 8: " . dgettext('mp',"Es ist ein Fehler beim Kopieren der Datei aufgetreten. Das Bild wurde nicht hochgeladen!");
	                                return $msg;
	                        }
	                }
			$photo_obj->set_file_content(base64_encode(file_get_contents($newfile)), base64_encode(file_get_contents($newfile_thumb)));
			@unlink($newfile);
			@unlink($newfile_thumb);
	                $msg = "msg" . sprintf(dgettext('mp',"Die Bilddatei \"%s\" wurde erfolgreich hochgeladen"),$img_name)."";
	                return $msg;
	        }
	        return FALSE;
	}

	// Liest ein Verzeichnis ein
	function GetDirContents($dir){
		ini_set("max_execution_time",100);
		if (!is_dir($dir)) return "error".sprintf(dgettext('mp',"Fehler! kein g&uuml;ltiges Verzeichnis: %s!"),$dir)."";
		if ($root=@opendir($dir)){
			while ($file=readdir($root)){
				if($file=="." || $file==".."){continue;}
				if(is_dir($dir."/".$file)){
					$files=array_merge($files,GetDirContents($dir."/".$file));
				}else{
					$files[]=$dir."/".$file;
				}
			}
		}
		return $files;
	}

	function add_new_zip($zipfile, $zipfile_size, $zipfile_name, $album_id) {
	        global $TMP_PATH;

		$db = new DB_Seminar();
	
	        $zipdir = $TMP_PATH."/".$contest_id."_".time();
	        $zipname = basename($zipfile).".zip";

		if ($zipfile_size > 50000 * 1024)
			return "error".dgettext('mp',"Die hochgeladene ZIP-Datei ist zu gross!");
	
	        if (!@copy($zipfile, $TMP_PATH."/$zipname")) return "error".dgettext('mp',"Fehler beim Kopieren des ZIP-Archivs!")."";;
	
	        // ZIP-Testing...
	        exec("unzip -t $TMP_PATH/$zipname 2>&1", $out, $err);
	        if ($err) return "error".dgettext('mp',"Fehler im ZIP-Archiv!")."";
	
	        unset($out);
	        unset($err);
	
	        // ZIP-Auspacking...
	        exec("unzip -jno $TMP_PATH/$zipname -d $zipdir 2>&1", $out, $err);
	        if ($err) return "error".dgettext('mp',"Fehler beim Entpacken des ZIP-Archivs!")."";
	
	        $files = $this->GetDirContents($zipdir);
	
	        if (!is_array($files)) return $files;
	
	        $good = 0;
	        $not_good = 0;
	
	        if (is_array($files))
	        foreach ($files as $key=>$val) {
			if ($this->get_absolut_content_size_in_db($GLOBALS['auth']->auth['uid']) > $this->max_quota_size)
	                        return "error".dgettext('mp',"Speicherplatz ersch&ouml;pft!");
	                //Dateiendung bestimmen
	                $ext = NULL;
	                $dot = strrpos($val,".");
	                if ($dot) {
	                        $l = strlen($val) - $dot;
	                        $ext = strtolower(substr($val,$dot+1,$l));
	                }
	
	                if (filesize($val)==0) {
	                        $not_good++;
	                        $msg .= "error".sprintf(dgettext('mp',"Fehler beim hochladen des Fotos: %s Dateigr&ouml;sse 0 Byte!"),basename($val))."";
	                        unlink($val);
	                        continue;
	                }

			$db->queryf("SELECT MAX(sort) maxsort FROM mp_photo WHERE album_id='%s'",$album_id);
			$db->next_record();
			$max_sort = ($db->f("maxsort") ? $db->f("maxsort") : 1);

			$file_id = md5(uniqid(time()));
        	        $p = new Photo();
       	                $p->set_file_id($file_id);
	                $msg2 = $this->imaging($p, $file_id, $val, filesize($val), basename($val));
        	        $pos = strpos($msg2, "error");
	                if ($pos===false) {
	                        $p->set_user_id($GLOBALS['auth']->auth['uid']);
        	                $p->set_album_id($album_id);
                	        $p->set_mkdate(time());
                        	$p->set_titel("");
	                        $p->set_beschreibung("");
				$p->set_ext($ext);
				$p->set_sort($max_sort + 1);
                	        $p->save();
				$good++;
	                } else {
				$not_good++;
				$msg .= $msg2;
			}
	                unlink($val);
	        }
	        $msg .= "msg".sprintf(dgettext('mp',"%d Bild(er) hochgeladen / %d Problem(e)"),$good,$not_good)."";
	        rmdir($zipdir);
	        unlink($TMP_PATH."/$zipname");
	        return $msg;
	}

	function image_download_fullsize(&$photo) {
		echo base64_decode($photo->get_file_content());
	}

	function image_download_thumb(&$photo) {
		echo base64_decode($photo->get_file_content_thumb());
	}
	

	function rotate($img, $degrees) {
		if(function_exists("imagerotate"))
            		return imagerotate($img, $degrees, 0);
        	else {
            		function imagerotate($src_img, $angle) {
                		$src_x = imagesx($src_img);
                		$src_y = imagesy($src_img);
                		if ($angle == 180) {
                    			$dest_x = $src_x;
                    			$dest_y = $src_y;
                		} elseif ($src_x <= $src_y) {
                    			$dest_x = $src_y;
                    			$dest_y = $src_x;
                		} elseif ($src_x >= $src_y) {
                    			$dest_x = $src_y;
                    			$dest_y = $src_x;
                		}

                		$rotate=imagecreatetruecolor($dest_x,$dest_y);
                		imagealphablending($rotate, false);

                		switch ($angle) {
                    			case 270:
                        			for ($y = 0; $y < ($src_y); $y++) {
                            				for ($x = 0; $x < ($src_x); $x++) {
                                				$color = imagecolorat($src_img, $x, $y);
                                				imagesetpixel($rotate, $dest_x - $y - 1, $x, $color);
                            				}
                        			}
                        			break;
                    			case 90:
                        			for ($y = 0; $y < ($src_y); $y++) {
                            				for ($x = 0; $x < ($src_x); $x++) {
                                				$color = imagecolorat($src_img, $x, $y);
	                                			imagesetpixel($rotate, $y, $dest_y - $x - 1, $color);
        	                    			}
                	        		}
                        			break;
                    			case 180:
                        			for ($y = 0; $y < ($src_y); $y++) {
                            				for ($x = 0; $x < ($src_x); $x++) {
                                				$color = imagecolorat($src_img, $x, $y);
	                                			imagesetpixel($rotate, $dest_x - $x - 1, $dest_y - $y - 1, $color);
        	                    			}
                	        		}
                        			break;
                    			default: $rotate = $src_img;
                		};
 	    			return $rotate;
            		}
            		return imagerotate($img, $degrees);
        	}
    	}

}

?>
