<?php
/**
* download.php
*
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2007 Jan Kulmann <jankul@zmml.uni-bremen.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


page_open(array("sess" => "Seminar_Session", "auth" => "Seminar_Default_Auth", "perm" => "Seminar_Perm", "user" => "Seminar_User"));

require_once("classes/myphoto/Photo.class.php");
require_once("classes/myphoto/Album.class.php");

$db=new DB_Seminar;
if (isset($photo_id)) {
	ob_start();

	$photo_id = escapeshellcmd(basename($photo_id));

	$p = new Photo();
	$p->load($photo_id);
	$a = new Album();
	$a->load($p->get_album_id());
	$have_va_perms = FALSE;
	foreach ($a->get_current_ranges() as $r)
		if ($GLOBALS['perm']->have_studip_perm("autor",$r))
			$have_va_perms = TRUE;


	//if (!($p->get_user_id() == $GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm("root") || $perm->have_studip_perm("dozent",$a->get_range_id()))) {
	if (!($p->get_user_id() == $GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm("root") || $have_va_perms)) {
		if ($a->get_public() == 0)
			exit;
	}

	if ($modus == "thumb") {
		$img = imagecreatefromstring(base64_decode($p->get_file_content_thumb()));
		$x_size = imagesx($img);
		$y_size = imagesy($img);
		if ($x_size <= 120) {
			$tmp_x1 = 0;
			$tmp_x2 = $x_size;
		} else {
			$tmp_x1 = floor(($x_size / 2) - 60);
			$tmp_x2 = floor(($x_size / 2) + 60);
		}
		if ($y_size <= 120) {
			$tmp_y1 = 0;
			$tmp_y2 = $y_size;
		} else {
			$tmp_y1 = floor(($y_size / 2) - 60);
			$tmp_y2 = floor(($y_size / 2) + 60);
		}

		$img2 = imagecreatetruecolor($tmp_x2-$tmp_x1, $tmp_y2-$tmp_y1);
		imagecopy($img2, $img, 0, 0, $tmp_x1, $tmp_y1, $tmp_x2-$tmp_x1, $tmp_y2-$tmp_y1);

		$data = base64_decode($p->get_file_content_thumb());
	}
	else
		$data = base64_decode($p->get_file_content());

	switch (strtolower($p->get_ext())) {
		case "gif":
			$content_type="image/gif";
			$content_disposition="inline";
			break;
		case "jpeg":
			$content_type="image/jpeg";
			$content_disposition="inline";
			break;
		case "jpg":
			$content_type="image/jpeg";
			$content_disposition="inline";
			break;
		default:
			break;
	}
	
	header("Expires: Mon, 12 Dec 2001 08:00:00 GMT");
	header("Last-Modified: " . gmdate ("D, d M Y H:i:s") . " GMT");
	if ($_SERVER['HTTPS'] == "on"){
	        header("Pragma: public");
        	header("Cache-Control: private");
	} else {
        	header("Pragma: no-cache");
	        header("Cache-Control: no-store, no-cache, must-revalidate");   // HTTP/1.1
	}
	header("Cache-Control: post-check=0, pre-check=0", false);
	header("Content-Type: $content_type; name=\"picture.".$p->get_ext()."\"");
	header("Content-Description: File Transfer");
	header("Content-Transfer-Encoding: binary");
	header("Accept-Ranges: bytes");
	header("Content-Length: ".strlen($data));
	header("Content-Disposition: $content_disposition; filename=\"picture.".$p->get_ext()."\"");
	ob_end_flush();

	if ($modus == "thumb") {
		if ($content_type == "image/gif")
			imagegif($img2);
		else if ($content_type == "image/jpeg")
			imagejpeg($img2);
		else
			echo $data;
	} else
		echo $data;
}

// Save data back to database.
page_close();
?>
